import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkNews, ThinkNewsParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkNews(params: ThinkNewsParam) {
  const res = await request.get<ApiResult<PageResult<ThinkNews>>>(
    THINK_API_URL + '/think/think-news/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkNews(params?: ThinkNewsParam) {
  const res = await request.get<ApiResult<ThinkNews[]>>(
    THINK_API_URL + '/think/think-news',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkNews(data: ThinkNews) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-news',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkNews(data: ThinkNews) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-news',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkNews(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-news/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkNews(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-news/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkNews(id: number) {
  const res = await request.get<ApiResult<ThinkNews>>(
    THINK_API_URL + '/think/think-news/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
